Bug 1312575 - patch (and other utilities) act oddly with respect to custom Linux LSM (i.e., replacing SELinux)
patch (and other utilities) act oddly with respect to custom Linux LSM (i.e.,...
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: patch (Show other bugs)
23
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Tim Waugh
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-02-27 08:45 EST by W. Michael Petullo
Modified: 2016-12-20 14:04 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-20 14:04:09 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description W. Michael Petullo 2016-02-27 08:45:21 EST
Description of problem:
I am working on a custom Linux security module. My module returns -EPERM when a non-root user-space process attempts to invoke getxattr on an extended attribute in the security domain (i.e., name is "security.[something]"). This is different than SELinux which allows non-root user-space processes to view but not update such security attributes.

I have noticed that at least patch and ls do not respond well to this. I realize that my LSM module exhibits non-standard behavior, but I would argue it is not unreasonable behavior. For example running patch causes this to happen:

$ patch -p1 < patch1
can't find file to patch at input line 3
Perhaps you used the wrong -p or --strip option?
The text leading up to this was:
[...]

This seems to be the result of the lgetxattr library call returning -EPERM, but clearly the error message is deceiving. I think patch ought to print that it cannot maintain the security attribute on the new file. Such an issue might be an error or a warning.

Version-Release number of selected component (if applicable):
patch-2.7.5-2.fc23.x86_64

How reproducible:
Every time

Additional info:
Other utilities exhibit similar behavior. I can address those with additional reports if the patch maintainers decide that this issue warrants attention.
Comment 1 Daniel Walsh 2016-02-29 14:49:13 EST
Michael, what is the security reasons for blocking reading xattr data on files that you own?  Could SELinux be special cased?
Comment 2 W. Michael Petullo 2016-02-29 16:33:37 EST
(In reply to Daniel Walsh from comment #1)
> Michael, what is the security reasons for blocking reading xattr data on
> files that you own?  Could SELinux be special cased?

We are writing a LSM which investigates an alternative security model. Thus we came across this while doing academic research. Our's is clearly not a normal use case, but I thought it might be worthwhile to point out that patch's error handling could be a little more clear and perhaps handle more possible error conditions.
Comment 3 Fedora End Of Life 2016-11-24 10:47:55 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 4 Fedora End Of Life 2016-12-20 14:04:09 EST
Fedora 23 changed to end-of-life (EOL) status on 2016-12-20. Fedora 23 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.